////////////////////////////////////////////////////////////////////////////////
//
//  ADOBE SYSTEMS INCORPORATED
//  Copyright 2009 Adobe Systems Incorporated
//  All Rights Reserved.
//
//  NOTICE: Adobe permits you to use, modify, and distribute this file
//  in accordance with the terms of the license agreement accompanying it.
//
////////////////////////////////////////////////////////////////////////////////
 
import flash.events.NativeWindowBoundsEvent;

private var movingReferenceEvent:NativeWindowBoundsEvent;

[Bindable]
public var applicationVersion:String = "(v1.18)";

/**
 * 	Display the custom chrome.
 */
private function showMain():void
{
	var descriptor:XML = NativeApplication.nativeApplication.applicationDescriptor;
	var ns:Namespace = descriptor.namespaceDeclarations()[0];
	applicationVersion = "(v"+descriptor.ns::version+")";
	
	nativeWindow.visible = true;
	nativeWindow.restore();
	nativeWindow.orderToFront();
	nativeWindow.addEventListener(NativeWindowBoundsEvent.MOVING, movingHandler);
}

private function movingHandler(event:NativeWindowBoundsEvent):void
{
	if (movingReferenceEvent != null)
		movingReferenceEvent.preventDefault();
	
	if (Math.abs(event.beforeBounds.x - event.afterBounds.x) > 100
		|| Math.abs(event.beforeBounds.y - event.afterBounds.y) > 100)
	{
		event.preventDefault();
		return;
	}
	movingReferenceEvent = event;	
}

private function startMove(event:MouseEvent):void
{
	if (movingReferenceEvent)
	{
		movingReferenceEvent.preventDefault();
	}
	else
	{
		if (event.buttonDown)
			stage.nativeWindow.startMove();
	}
}

[Bindable]
private var viewName:String = "(Record & Playback)";
private var lastViewIndex:int = 0;
private var examples:Array = ["mic", "tuner"]
private function changeView(view:String):void
{
	micSelector.visible = false;
	if (view == "left")
	{
		lastViewIndex = (lastViewIndex-1 < 0) ? 0 : lastViewIndex-1;
		view = examples[lastViewIndex];
	}
	else if (view == "right")
	{
		lastViewIndex = (lastViewIndex+1 >= examples.length) ? lastViewIndex : lastViewIndex+1;
		view = examples[lastViewIndex];
	}
	
	if (view != "info")
	{
		btnInfo.selected = false;
	}
	else
	{
		viewName = "(Application Info)";
		vsMain.selectedChild = pnlInfo;
	}
	if (view == "mic")
	{
		viewName = "(Record & Playback)";
		vsMain.selectedChild = pnlMic;
	}
	if (view == "tuner")
	{
		viewName = "(Pitch Detection)";
		vsMain.selectedChild = pnlTuner;
	}
		
}